(function () {
	var tree = $('.tree');
	$("#users_profiles_form").validate(Validations);
	var allCheckboxes = $('input[type="checkbox"]');

	tree.treegrid({
		initialState: 'collapsed'
	 });

	$('#superadmin').on('change', function () {
		var state = $(this).prop('checked');
		$('input[type=checkbox]').prop('checked', state);
	});

	$("button.up_expand_all").click(function() { // Expand all
		$('i#up_expand_spinner').addClass('active'); //Show spinner
		$.ajax({
			data: { delay:1 },
			success: function (data) {
				tree.treegrid('expandAll');
			}
		}).always(function(){
			  $('i#up_expand_spinner').removeClass('active');
		});
	});

	$("button.up_collapse_all").click(function() { // Collapse all
		$('i#up_expand_spinner').addClass('active'); //Show spinner
		$.ajax({
			data: { delay:1 },
			success: function (data) {
				tree.treegrid('collapseAll');
			}
		}).always(function(){
			  $('i#up_expand_spinner').removeClass('active');
		});
	});

	var chks, chksChecked, parent, dependent, level;
	var l1_menu = $("#users_profiles_form").find("#l1_menu").val();
	var l2_menu = $("#users_profiles_form").find("#l2_menu").val();
	var superadmin = $("#users_profiles_form").find('#superadmin').val();

	allCheckboxes.on('change', function() {
		var checked = $(this).is(':checked');
		parent = $(this).data('parent');

		$('.pt_' + parent).prop('checked', checked);

		level = $(this).data('level');
		dependent = $(this).data('dep');

		chks = tree.find('.dp_' + dependent).length;
		chksChecked = tree.find('.dp_' + dependent + ':checked').length;

		switch (level) {
			case 1:
				chks = $('.first_level').length;
				chksChecked = $('.first_level:checked').length;
				$('#superadmin').prop('checked', (chks === chksChecked));
				if(superadmin == 1 && parent == l1_menu) { set_user_profile(); }
				break;

			case 2:
				$('.fl_' + dependent).prop('checked', (chks === chksChecked));
				console.log(superadmin, parent, l2_menu);
				if(superadmin == 1 && parent == l2_menu) { set_user_profile(); }
				break;

			case 3:
				$('.sl_' + dependent).prop('checked', (chks === chksChecked));
				break;

			default :
				chks = $(this).parent().parent().find('.dp_' + dependent).length;
				chksChecked = $(this).parent().parent().find('.dp_' + dependent + ':checked').length;
				$('.tl_' + dependent).prop('checked', (chks === chksChecked));
				break;
		}
	});

	$('.third_level').each(function() {
		dependent = $(this).data('dep');
		parent = $('.sl_' + dependent);
		checkParent(parent, dependent);
	});

	$('.second_level').each(function() {
		dependent = $(this).data('dep');
		parent = $('.fl_' + dependent);
		checkParent(parent, dependent);
	});

	$('.first_level').each(function() {
		chks = $('.first_level').length;
		chksChecked = $('.first_level:checked').length;
		$('#superadmin').prop('checked', (chks === chksChecked));
	});

	function checkParent(parent, dependent) {
		var chks = tree.find('.dp_' + dependent).length;
		var chksChecked = tree.find('.dp_' + dependent + ':checked').length;
		parent.prop('checked', (chks === chksChecked));
	}

	function set_user_profile() {
		var module_id = $("#users_profiles_form").find("#disabled_module").val();
		user_profile_module = $("#users_profiles_form").find("#priv\\[" + module_id + "\\]\\[allowMod\\]");
		user_profile_module.prop('checked', true); //check the module
		deps = user_profile_module.data('parent');
		tree.find('.dp_' + deps).prop('checked', true); //check module privs

		// bubble up
		parent = user_profile_module.data('dep');
		chks = tree.find('.dp_' + parent).length;
		chksChecked = tree.find('.dp_' + parent + ':checked').length;
		tree.find('.sl_' + parent).prop('checked', (chks === chksChecked));
	}
})();
